# mypy-boto3-storagegateway

[![PyPI - mypy-boto3-storagegateway](https://img.shields.io/pypi/v/mypy-boto3-storagegateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-storagegateway)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-storagegateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-storagegateway)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-storagegateway](#mypy-boto3-storagegateway)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.StorageGateway 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/storagegateway.html#StorageGateway) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-storagegateway](#mypy-boto3-storagegateway)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `StorageGateway` service.

```bash
python -m pip install boto3-stubs[storagegateway]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_storagegateway` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_storagegateway import StorageGatewayClient

# Now mypy can check if your code is valid.
client: StorageGatewayClient = boto3.client("storagegateway")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: StorageGatewayClient = session.client("storagegateway")



# Annotated paginators are included as well

import mypy_boto3_storagegateway.paginator as storagegateway_paginators

describe_tape_archives_paginator: storagegateway_paginators.DescribeTapeArchivesPaginator = client.get_paginator("describe_tape_archives")
describe_tape_recovery_points_paginator: storagegateway_paginators.DescribeTapeRecoveryPointsPaginator = client.get_paginator("describe_tape_recovery_points")
describe_tapes_paginator: storagegateway_paginators.DescribeTapesPaginator = client.get_paginator("describe_tapes")
describe_vtl_devices_paginator: storagegateway_paginators.DescribeVTLDevicesPaginator = client.get_paginator("describe_vtl_devices")
list_file_shares_paginator: storagegateway_paginators.ListFileSharesPaginator = client.get_paginator("list_file_shares")
list_gateways_paginator: storagegateway_paginators.ListGatewaysPaginator = client.get_paginator("list_gateways")
list_tags_for_resource_paginator: storagegateway_paginators.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
list_tapes_paginator: storagegateway_paginators.ListTapesPaginator = client.get_paginator("list_tapes")
list_volumes_paginator: storagegateway_paginators.ListVolumesPaginator = client.get_paginator("list_volumes")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_storagegateway` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_storagegateway as storagegateway
from mypy_boto3_storagegateway import StorageGatewayClient

# with these
from mypy_boto3 import storagegateway
from mypy_boto3.storagegateway import StorageGatewayClient
```